// prepreka
// rešitev s ključavnicami - ne deluje - pride do tveganega stanja (race condition)
// kakšna nit je lahko že v novem ciklu preden nit 0 resetira števec

#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>
#include <Windows.h>

#define	NTHREADS	4
#define NPRINTS		5

int threads;
int shared;
pthread_mutex_t lock;

void* barrier(void* arg) 
{
	int i;
	int myid = (int)arg;

	for(i=0; i<NPRINTS; i++)
	{
		if( myid == 0 )
			shared++;
			
		// prepreka - zacetek
		pthread_mutex_lock(&lock);
		threads++;
		pthread_mutex_unlock(&lock);
		while( threads < NTHREADS );
		// prepreka - konec

		printf("Nit %d: vrednost: %d\n", myid, shared);

		if( myid == 0 )
			threads = 0;		
	}

	return NULL;
}

int main(int argc, char *argv[]) 
{
	int i;
	pthread_t t[NTHREADS];

	shared = 0;
	threads = 0;

	pthread_mutex_init(&lock, NULL);

	for(i=0; i<NTHREADS; i++)
		pthread_create(&t[i], NULL, barrier, (void *)i);

	for(i=0; i<NTHREADS; i++)
		pthread_join(t[i], NULL);

	pthread_mutex_destroy(&lock);

	return 0;
}
