// prepreka
// s semaforji:
//   spremenljivka threads je lahko uporabljena večkrat, saj jo resetiramo preden spustimo vse niti naprej
//   ponovno lahko uporabimo tudi semafor counter
//   izmenično uporabljamo semaforja block in block2, do težav naj ne bi več prišlo, grda rešitev

#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>
#include <Windows.h>

#define	NTHREADS	10
#define NPRINTS		10

int threads;
int shared;

sem_t counter, block, block2;

void* barrier(void* arg) 
{
	int i, j;
	int myid = (int)arg;	

	for(i=0; i<NPRINTS; i++)
	{
		if( myid == 0 )
			shared++;

		// prepreka - zacetek
		sem_wait(&counter);
		if( threads < NTHREADS-1 )
		{
			threads++;
			sem_post(&counter);
			if( i%2 == 0 )
				sem_wait(&block);
			else
				sem_wait(&block2);
		}
		else
		{
			threads = 0;
			sem_post(&counter);
			for( j=0; j<NTHREADS-1; j++)
				if( i%2 == 0 )
					sem_post(&block);
				else
					sem_post(&block2);
		}
		// prepreka - konec

		printf("Nit %d: vrednost: %d\n", myid, shared);
	}

	return NULL;
}

int main(int argc, char *argv[]) 
{
	int i;
	pthread_t t[NTHREADS];

	shared = 0;

	sem_init(&counter, 0, 1);
	sem_init(&block, 0, 0);
	sem_init(&block2, 0, 0);

	for(i=0; i<NTHREADS; i++)
		pthread_create(&t[i], NULL, barrier, (void *)i);

	for(i=0; i<NTHREADS; i++)
		pthread_join(t[i], NULL);

	sem_destroy(&counter);
	sem_destroy(&block);
	sem_destroy(&block2);

	return 0;
}
